
FN = {}
FN.debug = false

local unitPlayer
local targetUnit
local targetCoor
local frequency = 0
local modulation = ""
local broadcastUnitName = ""
local radioBroadcasting = false
local preSound = ""
local preSoundDuration = 0
local postSound = ""
local postSoundDuration = 0
local preSentence = ""
local postSentence = ""


local trackingType --unit or coor



function FN.BroadcastSound(aSoundFile,aDuration)

	if (not radioBroadcasting) then
		FSQ.AddSoundToAll(aSoundFile,aDuration)
	else
		
		FSQ.AddRadioCall(aSoundFile,aDuration,broadcastUnitName,modulation,frequency)
		
		if (FN.debug) then
			trigger.action.outText("FN: BroadCast (Radio): "..tostring(frequency).." Modulation: "..modulation.." Broadcast unit: "..broadcastUnitName.." Soundfile "..aSoundFile, 10)
		end

	end --if

end --function

function FN.StackNumberSound(aNumber)

	if (aNumber==0) then
		FN.BroadcastSound("0.ogg",0.43)
	elseif (aNumber==1) then
		FN.BroadcastSound("01.ogg",0.33)
	elseif (aNumber==2) then
		FN.BroadcastSound("02.ogg",0.35)
	elseif (aNumber==3) then
		FN.BroadcastSound("03.ogg",0.38)
	elseif (aNumber==4) then
		FN.BroadcastSound("04.ogg",0.31)
	elseif (aNumber==5) then
		FN.BroadcastSound("05.ogg",0.32)
	elseif (aNumber==6) then
		FN.BroadcastSound("06.ogg",0.53)
	elseif (aNumber==7) then
		FN.BroadcastSound("07.ogg",0.47)
	elseif (aNumber==8) then
		FN.BroadcastSound("08.ogg",0.30)
	elseif (aNumber==9) then
		FN.BroadcastSound("09.ogg",0.45)
	end

end --function


function FN.AddSoundForHeading(aHeading)

	
	if (preSound~="") then
		if (FN.debug) then
			trigger.action.outText("FN: Playing preSound: "..preSound, 10)
		end
		FN.BroadcastSound(preSound,preSoundDuration)
	end
	
	if (aHeading==0) then
		FN.StackNumberSound(0)
	else
		local _hundred = math.floor(aHeading / 100)
		local _tenth = math.floor((aHeading - (_hundred * 100)) / 10)
		local _unit = aHeading - (_hundred * 100) - (_tenth * 10)

		if (FN.debug) then
			trigger.action.outText("FN:"..tostring(_hundred).."-"..tostring(_tenth).."-"..tostring(_unit),10)
		end
		
		FN.StackNumberSound(_hundred)
		FN.StackNumberSound(_tenth)
		FN.StackNumberSound(_unit)
	end
	
	if (postSound~="") then
		if (FN.debug) then
			trigger.action.outText("FN: Playing postSound: "..postSound, 10)
		end
		FN.BroadcastSound(postSound,postSoundDuration)
	end

end --function


function FN.SetRadio(aFrequency,aModulation,aBroadcastUnit)
	
	if (FN.debug) then
		trigger.action.outText("FN: SetRadio Frequency: "..tostring(aFrequency).." Modulation: "..aModulation.." Broadcast unit: "..aBroadcastUnit, 10)
	end

	
	frequency=aFrequency
	modulation=aModulation
	broadcastUnitName=aBroadcastUnit
	radioBroadcasting=true
	
end --function

function FN.SetPrePosSound(aPreSound,aPreSoundDuration,aPostSound,aPostSoundDuration)
	
	if (FN.debug) then
		trigger.action.outText("FN: Adding pre/post sound. Pre: "..aPreSound.." Post: "..aPostSound, 10)
	end
	preSound = aPreSound
	preSoundDuration = aPreSoundDuration
	postSound = aPostSound
	postSoundDuration = aPostSoundDuration
	
end --function

function FN.SetPrePosSentence(aPreSentence,aPostSentence)

	preSentence = aPreSentence
	postSentence = aPostSentence

end --function

function FN.SetTargetCoor(aPlayerUnitName,xCoor,zCoor)

	unitPlayer = UNIT:FindByName(aPlayerUnitName) 
	targetCoor = COORDINATE:New(xCoor,0,zCoor)
	trackingType = "coor"
	
end --function

function FN.SetTargetUnit(aPlayerUnitName,aTargetUnitName)

	unitPlayer = UNIT:FindByName(aPlayerUnitName) 
	targetUnit = UNIT:FindByName(aTargetUnitName) 
	trackingType = "unit"
	
end --function



function FN.BroadcastHeading()

    if (FN.debug) then
		trigger.action.outText("FN: BROADCAST HEADING",10) 
	end
	
    playerCoord = unitPlayer:GetCoordinate()     -- Convert Vec3 to Coordinate
	
	if (trackingType=="unit") then
		targetCoor = targetUnit:GetCoordinate()
	end
	
    targetDistance = playerCoord:Get2DDistance( targetCoor )  -- Returns distance in meters   


    targetVector = playerCoord:GetDirectionVec3( targetCoor )  --Returns vector in Vec3 to To_Grp
    bearingToTarget = playerCoord:GetAngleRadians( targetVector ) -- Returns bearing Bomber to To_Grp
    pathInfo = playerCoord:GetBRText( bearingToTarget, targetDistance, _SETTINGS:SetImperial() )  -- Returns bearing, distance text
      
	trackingDisplay = preSentence.." ".. pathInfo.." "..postSentence
	  
	local _Angle = UTILS.Round( UTILS.ToDegree( bearingToTarget ), 0 )
	  
	--MessageToAll("Bearing: "..tostring(_Angle),10,"")

	MessageTo_Grp = MESSAGE:New( trackingDisplay, 30, nil ):ToAll()
	FN.AddSoundForHeading(_Angle)

end --function

function FN.StartLoopTracking(anIntervalInSeconds)

	if (FN.debug) then
		trigger.action.outText("FN: StartLoopTracking. Interval: "..tostring(anIntervalInSeconds).." seconds",10)
	end


	FNScheduler = SCHEDULER:New( nil, FN.BroadcastHeading,{},1,anIntervalInSeconds)	
	

end -- function


function FN.StopTracking()

	FNScheduler:Stop()

	if (FN.debug) then
		trigger.action.outText("FN: Stop tracking.",10)
	end

end

--function


